﻿#include <iostream>
#include <MSFS/MSFS.h>
#include <MSFS/MSFS_CommBus.h>
#include <MSFS/MSFS_WindowsTypes.h>
#include <SimConnect.h>
#include <stdio.h>
#include <string>

#include "Module.h"

// -----------------------------------------------------------------------------

HANDLE SimConnectHandle;
const char* TestEventName = "test_event_name";

// -----------------------------------------------------------------------------

void EventCallback( const char* buf, unsigned int bufSize, void* ctx )
{
	std::string Data( buf, bufSize );
	std::cout << Data;
}

// -----------------------------------------------------------------------------

void CALLBACK CallDispatch( SIMCONNECT_RECV* pData, DWORD cbData, void* pContext )
{
	switch ( pData->dwID )
	{
	case SIMCONNECT_RECV_ID_OPEN:
		// Fire event to self after the SimConnect connection has opened - EventCallback is called in this case
		std::string Data( "Event data from DispatchProc" );
		fsCommBusCall( TestEventName, Data.c_str(), Data.size(), FsCommBusBroadcast_AllWasm );
		break;
	}
}

// -----------------------------------------------------------------------------

extern "C" MSFS_CALLBACK void module_init()
{
	// Simconnect connection
	SimConnectHandle = 0;
	if ( SimConnect_Open( &SimConnectHandle, "Standalone Module", NULL, 0, 0, 0 ) != S_OK )
	{
		std::cerr << "Failed to open SimConnect connection";
		return;
	}

	if ( SimConnect_CallDispatch( SimConnectHandle, CallDispatch, NULL ) != S_OK )
	{
		std::cerr << "Failed to set dispatch proc";
		return;
	}

	// Commbus init
	fsCommBusRegister( TestEventName, &EventCallback, nullptr );

	// Fire event to self from module_init - EventCallback never called with this data
	std::string Data( "Event data from module_init" );
	fsCommBusCall( TestEventName, Data.c_str(), Data.size(), FsCommBusBroadcast_AllWasm );
}

// -----------------------------------------------------------------------------

extern "C" MSFS_CALLBACK void module_deinit()
{
}

// -----------------------------------------------------------------------------
// -----------------------------------------------------------------------------
// -----------------------------------------------------------------------------
